package com.unionpay.acp.sdk;

import com.google.gson.Gson;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.TreeMap;


public class MD5Util {

    private static char hexDigits[] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};

    private static MessageDigest messagedigest = null;

    static {
        try {
            messagedigest = MessageDigest.getInstance("MD5");
        } catch (NoSuchAlgorithmException nsaex) {
            System.err.println(MD5Util.class.getName() + "Initializing messagedigest fails，MessageDigest dose not support MD5Util.");
            nsaex.printStackTrace();
        }
    }

    static Logger logger = LoggerFactory.getLogger(AppCommonUtils.class);


    public static String encrypt(String dataStr) {
        try {
            MessageDigest m = MessageDigest.getInstance("MD5");
            m.update(dataStr.getBytes("UTF8"));
            byte s[] = m.digest();
            String result = "";
            for (int i = 0; i < s.length; i++) {
                result += Integer.toHexString((0x000000FF & s[i]) | 0xFFFFFF00)
                        .substring(6);
            }
            return result;
        } catch (Exception e) {
            e.printStackTrace();
        }

        return "";
    }

    public static String getMD5StrObject(Object object, String signKey) {
        String jsonStr = sort(object, signKey);
        String md5Str = getMD5String(jsonStr).toUpperCase();
        return md5Str;
    }

    /**
     * 按照字段名称（0-9A-z）升序排列取得对应字段值拼接
     *
     * @param object
     * @return
     */
    public static String sort(Object object, String signKey) {
        Gson g = new Gson();
        String json = g.toJson(object);
        TreeMap<String, Object> map = g.fromJson(json, TreeMap.class);
        StringBuilder stb = new StringBuilder();
        for (String str : map.keySet()) {
            if(!str.equals("sign")){
                Object obj_ins = map.get(str);
                if(obj_ins instanceof Double){
                    String int_val = String.valueOf(obj_ins);
                    int_val = int_val.substring(0, int_val.length()-2);
                    stb.append(str+"="+int_val+"&");
                }else{
                    stb.append(str+"="+String.valueOf(map.get(str))+"&");
                }
            }
        }
        String data = stb.toString()+"key="+signKey;
        //logger.info("sort data: {}",data);
        //LogUtil.d("原串数据：" + data);
        return data;
    }

    public static String getMD5String(String s) {
        String result = "";
        try {
            result = getMD5_byBytes(s.getBytes("utf-8"));
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return result;
    }

    public static String getMD5_byBytes(byte[] bytes) {
        messagedigest.update(bytes);
        return bufferToHex(messagedigest.digest());
    }

    private static String bufferToHex(byte bytes[]) {
        return bufferToHex(bytes, 0, bytes.length);
    }

    private static String bufferToHex(byte bytes[], int m, int n) {
        StringBuffer stringbuffer = new StringBuffer(2 * n);
        int k = m + n;
        for (int l = m; l < k; l++) {
            appendHexPair(bytes[l], stringbuffer);
        }
        return stringbuffer.toString();
    }

    private static void appendHexPair(byte bt, StringBuffer stringbuffer) {
        char c0 = hexDigits[(bt & 0xf0) >> 4];
        char c1 = hexDigits[bt & 0xf];
        stringbuffer.append(c0);
        stringbuffer.append(c1);
    }
}

